/*
 * Copyright 2002-2005 webapp2.net
 *
 *   the Apache License, Version 2.0 ϴ:
 *
 * 	http://www.apache.org/licenses/LICENSE-2.0
 *
 */
package net.webapp2.forum.dao;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import net.webapp2.forum.domain.Post;


import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;
/**
 * PostDao implement
 *
 * @author Ahn, Younghoe
 * @author Baik, Keesun
 */
public class SqlmapPostDao extends SqlMapClientDaoSupport implements PostDao {

	public void save(Post post) {

		Integer id = (Integer) getSqlMapClientTemplate().insert("Post.insert",
				post);
		post.setId(id);

	}

	public Post load(Integer id) {

		return (Post) getSqlMapClientTemplate().queryForObject("Post.load", id);

	}

	public Post loadReply(int id) {

		Post reply = load( id );
		reply.setParent(load( load(id).getParent().getId() ));
		return reply;
	}

	public void update(Post post) {

		getSqlMapClientTemplate().update("Post.update", post);

	}

	public void delete(Integer id) {

		getSqlMapClientTemplate().delete("Post.delete", id);
	}

	@SuppressWarnings("unchecked")
	public List<Post> list(int i) {

		return getSqlMapClientTemplate().queryForList("Post.list", i);
	}

	@SuppressWarnings("unchecked")
	public List<Post> find(String property, Object keyword) {

		Map<String, Object> params = new HashMap<String, Object>();
		params.put("property", property);
		params.put("keyword", keyword);

		return getSqlMapClientTemplate().queryForList("Post.find", params);
	}

}
