/*
 * Copyright 2002-2005 webapp2.net
 *
 * 본 파일은 the Apache License, Version 2.0를 따릅니다:
 *
 * 	http://www.apache.org/licenses/LICENSE-2.0
 *
 */
package net.webapp2.member.dao;

import java.util.List;

import net.webapp2.member.domain.Member;
import net.webapp2.member.domain.Role;

/**
 * @author Park, chanwook
 * @author Beak, keesun
 *
 */
public interface MemberDao {

	public void insert(Member member);

	public Member login(String id, String password);

	public void update(Member member);

	public void delete(String id);

	public Member load(String id);

	public List<Member> list();

	public List<Member> find(String property, String value);

	public void provideRole(String role_name, String member_id);

	public List<Role> loadRoleInfo(String property, String value);

}
