/*
 * Copyright 2002-2005 webapp2.net
 *
 * 본 파일은 the Apache License, Version 2.0를 따릅니다:
 *
 * 	http://www.apache.org/licenses/LICENSE-2.0
 *
 */
package net.webapp2.member.dao;

import java.util.List;
import java.util.Map;

import net.webapp2.member.domain.Member;
import net.webapp2.member.domain.Role;
import net.webapp2.util.ParamUtil;

import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;

/**
 * @author Park, chanwook
 * @author Beak, keesun
 *
 */
public class SqlmapMemberDao extends SqlMapClientDaoSupport implements
		MemberDao {

	public void insert(Member member) {
		getSqlMapClientTemplate().insert("Member.insert", member);
	}

	public Member login(String id, String password) {
		Map<String, String> params = ParamUtil.getParams(id, password);

		return (Member)getSqlMapClientTemplate().queryForObject("Member.login", params);
	}

	public void update(Member member) {
		getSqlMapClientTemplate().update("Member.update", member);
	}

	public void delete(String id) {
		getSqlMapClientTemplate().delete("Member.delete", id);
	}

	public Member load(String id) {
		return (Member)getSqlMapClientTemplate().queryForObject("Member.load", id);
	}

	@SuppressWarnings("unchecked")
	public List<Member> list() {
		return getSqlMapClientTemplate().queryForList("Member.list", null);
	}

	@SuppressWarnings("unchecked")
	public List<Member> find(String property, String value) {
		Map<String, String> params = ParamUtil.getParams(property, value);

		return getSqlMapClientTemplate().queryForList("Member.find", params);
	}

	public void provideRole(String role_name, String member_id) {
		Map<String, String> params = ParamUtil.getParams(role_name, member_id);

		getSqlMapClientTemplate().insert("Member.provideRole", params);
	}

	@SuppressWarnings("unchecked")
	public List<Role> loadRoleInfo(String property, String value) {
		Map<String, String> params = ParamUtil.getParams(property, value);

		return (List<Role>)getSqlMapClientTemplate().queryForList("Member.loadRoleInfo", params);
	}
}
