/*
 * Copyright 2002-2005 webapp2.net
 *
 * 본 파일은 the Apache License, Version 2.0를 따릅니다:
 *
 * 	http://www.apache.org/licenses/LICENSE-2.0
 *
 */
package net.webapp2.member.domain;

import java.util.Date;

/**
 * 회원
 *
 * @author Ahn, Younghoe
 * @author Park, chanwook
 *
 *
 */
public class Member {

	/**
	 * 회원 식별자. 회원이 직접 입력함.
	 *
	 * <p>제약 사항</p>
	 * <p>- 길이: 3 ~ 15</p>
	 * <p>반드시 입력해야함. 동일한 id가 존재하면 안됨.</p>
	 */
	private String id;

	/**
	 * 회원 이름. 회원이 직접 입력함.
	 * <p>제약사항</p>
	 * <p>- 길이: 1 ~ 50, 반드시 입력</p>
	 *
	 */
	private String name;

	/**
	 * 회원 별칭. 회원이 직접 입력함.
	 * <p>제약사항</p>
	 * <p>- 길이: 0 ~ 50</p>
	 */
	private String alias;

	/**
	 * 회원 이메일. 회원이 직접 입력함.
	 * <p>제약사항</p>
	 * <p>- 길이: 0 ~ 50, 반드시 입력</p>
	 *
	 */
	private String email;

	/**
	 * 회원 블로그. 회원이 직접 입력함.
	 * <p>제약사항</p>
	 * <p>- 길이: 0 ~ 100</p>
	 */
	private String blog;

	/**
	 * 회원 암호. 회원이 직접 입력함.
	 * <p>제약사항</p>
	 * <p>- 길이: 4 ~ 15, 반드시 입력</p>
	 */
	private String password;

	/**
	 * 회원 가입일. 가입시에 값 생성.
	 * <p>제약사항</p>
	 * <p>date type, 반드시 입력</p>
	 */
	private Date joined;

	public String getAlias() {
		return alias;
	}

	public void setAlias(String alias) {
		this.alias = alias;
	}

	public String getBlog() {
		return blog;
	}

	public void setBlog(String blog) {
		this.blog = blog;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public Date getJoined() {
		return joined;
	}

	public void setJoined(Date joined) {
		this.joined = joined;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

}
