/*
 * Copyright 2002-2005 webapp2.net
 *
 * 본 파일은 the Apache License, Version 2.0를 따릅니다:
 *
 * 	http://www.apache.org/licenses/LICENSE-2.0
 *
 */
package net.webapp2.member.domain;

import java.util.List;

import net.webapp2.member.dao.MemberDao;
import net.webapp2.member.service.MemberService;

/**
 * @author Park, chanwook
 * @author Beak, keesun
 *
 */
public class MemberServiceImpl implements MemberService {
	private MemberDao memberDao;

	public void setMemberDao(MemberDao memberDao) {
		this.memberDao = memberDao;
	}

	public void join(Member member) {
		memberDao.insert(member);	}

	public Member login(String id, String password) {
		Member member = memberDao.login(id, password);
		return member;
	}

	public void update(Member member) {
		memberDao.update(member);
	}

	public void delete(String id) {
		memberDao.delete(id);
	}

	public Member load(String id) {
		Member member = memberDao.load(id);
		return member;
	}

	public List<Member> list() {
		List<Member> member = memberDao.list();
		return member;
	}

	public List<Member> find(String property, String value) {
		List<Member> member = memberDao.find(property, value);
		return member;
	}

	public void provideRole(String role_name, String member_id) {
		memberDao.provideRole(role_name, member_id);
	}

	public List<Role> loadRoleInfo(String property, String value) {
		List<Role> role = memberDao.loadRoleInfo(property, value);
		return role;
	}

}
