/*
 * Copyright 2002-2005 webapp2.net
 *
 * 본 파일은 the Apache License, Version 2.0를 따릅니다:
 *
 * 	http://www.apache.org/licenses/LICENSE-2.0
 *
 */
package net.webapp2.util;

/**
 * @author Park, chanwook
 *
 */
public class DBUtil {
	/**
	 * name 프라퍼티가 DB 제약조건에 부합되는지 체크
	 * @param name
	 * @return boolean
	 */
	public static boolean checkName(String name){

		boolean returnValue = true;

		if((name == "") || (name == null) || (!(name instanceof String)) ||
				(name.length() > 50)){
			returnValue = false;
		}
		return returnValue;
	}

	/**
	 * email 프라퍼티가 DB 제약조건에 부합되는지 체크
	 * @param email
	 * @return boolean
	 */
	public static boolean checkEmail(String email){

		boolean returnValue = true;

		if((email == "") || (email == null) || (!(email instanceof String)) ||
				(email.length() > 50)){
			returnValue = false;
		}
		return returnValue;
	}

	/**
	 * id 프라퍼티가 DB 제약조건에 부합되는지 체크
	 * @param id
	 * @return boolean
	 */
	public static boolean checkId(String id){

		boolean returnValue = true;

		if((id == null) || (!(id instanceof String)) ||
				(id.length() > 15) || (id.length() < 3)){
			returnValue = false;
		}
		return returnValue;
	}

	/**
	 * password 프라퍼티가 DB 제약조건에 부합되는지 체크
	 * @param password
	 * @return boolean
	 */
	public static boolean checkPassword(String password) {

		boolean returnValue = true;

		if((password == null) || (!(password instanceof String)) ||
				(password.length() > 15) || (password.length() < 4)){
			returnValue = false;
		}
		return returnValue;
	}

}
