-- UserInfo table
DROP TABLE UserInfo IF EXISTS CASCADE;
CREATE TABLE UserInfo (
	id VARCHAR (15),
	name VARCHAR (20) NOT NULL,
	password VARCHAR (15) NOT NULL,
	email VARCHAR (50) NOT NULL,
	regi_date DATE NOT NULL,
	blog VARCHAR (50),
	phone VARCHAR (35),
	CONSTRAINT pk_userinfo PRIMARY KEY (id)
);

-- Role table
DROP TABLE Role IF EXISTS CASCADE;
CREATE TABLE Role (
	id INTEGER IDENTITY,
	name VARCHAR (20) NOT NULL,
	CONSTRAINT pk_role PRIMARY KEY (id)
);

-- UserInfo_Role table
DROP TABLE UserInfo_Role IF EXISTS CASCADE;
CREATE TABLE UserInfo_Role (
	userinfo_ref VARCHAR (15),
	role_ref INTEGER,
	CONSTRAINT pk_userinfo_role PRIMARY KEY (userinfo_ref, role_ref),
	CONSTRAINT fk_userinfo FOREIGN KEY (userinfo_ref) REFERENCES UserInfo(id),
	CONSTRAINT fk_role FOREIGN KEY (role_ref) REFERENCES  Role(id)
);


