package calendar.web;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.Controller;

import calendar.dao.CalendarDao;
import calendar.domain.Calendar;

public class CalendarListController implements Controller {

	private CalendarDao calendarDao;

//	@SuppressWarnings("deprecation")
//	@Override
//	protected ModelAndView handleRequestInternal(HttpServletRequest request,
//			HttpServletResponse response) throws Exception {
//
////		long start = System.currentTimeMillis();
//		List<Calendar> model = calendarDao.getDefaultList();
//		String date = request.getParameter("date");
//		System.out.println("parameter value = " + date);
//		if (date.equals(null) || date.equals("")) {
//			model = calendarDao.getDefaultList();
//		} else {
//			model = calendarDao.getListByDay(date);
//		}
////		System.out.println(System.currentTimeMillis() - start);
//
//		return new ModelAndView("index", "calendarList", model);
//	}

	@SuppressWarnings("deprecation")
	public ModelAndView handleRequest(HttpServletRequest request, HttpServletResponse response) {

		List<Calendar> calList;
		String req = request.getParameter("datetime");
		Date currentDate = (req == null) ? new Date() : new Date(new Long(req));
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		String date = dateFormat.format(currentDate).toString();

		if (req == null || req.equals("")) {
			calList = calendarDao.getDefaultList();
		} else {
			calList = calendarDao.getListByDay(date);
		}

		Map<String,Object> model = new HashMap<String, Object>();
		model.put("calendarList", calList);
		model.put("datetime", date);

		return new ModelAndView("calendar", model);
	}

	public void setCalendarDao(CalendarDao calendarDao) {
		this.calendarDao = calendarDao;
	}

}
