package net.webapp2.article.dao;

import java.util.List;

import net.webapp2.article.domain.Article;
import net.webapp2.article.domain.Category;


/**
 * @author younghoe
 *
 */
public interface ArticleDao {

//	/**
//	 * 데이터베이스 레코드에 기초한 실제 기술문서 개수
//	 */
//	final String ACTUAL_ARTICLE_COUNT = "actualCount";
//
//	/**
//	 * 데이티베이스 기술문서 관리번호의 가장 큰 수
//	 */
//	final String LARGEST_ARTICLE_ID = "largestId";
//

//	public Integer insert(Article entry);
//
//	/**
//	 * 관리번호를 이용하여 Article 객체를 얻음
//	 *
//	 * @param id
//	 *            관리번호
//	 * @return Article 객체
//	 */
//	public Article get(Integer id);
//
//	/**
//	 * Article 객체 변경을 데이터베이스에 반영. 매개변수로 제공되는 겍체의 경우
//	 * 반드시 관리번호가 부여되어 있어야 하며, 효율적인 수행을 위해서는
//	 * 관리번호 이외에는 수정된 속성만 포함하는 것이 좋다.
//	 * @param article
//	 *            변경된 Article 객체
//	 * @return 변경된 데이터베이스 레코드 개수
//	 */
//	public int update(Article article);
//
//	/**
//	 * 관리번호를 이용하여 Article 객체의 정보를 데이터베이스에서 삭제
//	 *
//	 * @param id
//	 *            삭제하려는 Article 객체의 관리번호
//	 * @return 삭제된 데이터베이스 레코드 개수
//	 */
//	public int delete(Integer id);
//
//	/**
//	 * 통계 데이터에 기초한 총계
//	 * @return 데이터베이스에 저장된 Article 객체의 개수
//	 */
//	public Integer count();
//
//	/**
//	 * Article 객체의 정보를 포함하는 실제 레코드 수를 헤아림
//	 * @return 객체의 정보를 포함하는 실제 레코드 수
//	 */
//	public Map<String, Integer> countAsItIs();
//
//	/**
//	 * 데이터베이스의 Article 객체 관련 통계 정보를 실제 데이터베이스
//	 * 레코드 현황에 맞추는 보정
//	 * @param issueCount 실제 Article 레코드 개수
//	 * @param delCount 삭제된 Article 레코드 관리번호
//	 */
//	public void resetStat(Integer issueCount, Integer delCount);
//
	/**
	 * 데이터베이스의 모든 Article 객체를 반환
	 * @return 모든 Article 객체
	 */
	public List<Article> queryForArticleList();

	/**
	 * @link Article 객체를 데이터베이스에 입력. Article 객체의 다음 속성은 null이면 안된다.
	 * <ul>
	 *  <li>id
	 *  <li>link
	 *  <li>title
	 *  <li>language
	 *  <li>postedTime
	 * </ul>
	 * @param article DB에 입력할 기술문서 객체
	 * @return 입력한 글을 조회하기 위하여 기술문서키값을 가져온다.
	 */
	public void insert(Article article);

	/**
	 * @link Category 객체를 데이터베이스에 입력. Category 객체의 다음 속성은 null이면 안된다.
	 * <ul>
	 * 	<li>id
	 *  <li>name
	 * </ul>
	 * @param category DB에 입력할 주제어 객체
	 */
	public void insert(Category category);

	/**
	 * 특정 관리번호의 Article 객체 요청
	 * @param id 기술문서 관리번호
	 * @return 주어진 관리번호의 Article 객체
	 */
	public Article getArticle(Integer id);

	/**
	 * Article 객체 저장
	 * @param article 저장 대상 객체
	 */
	public void save(Article article);

	/**
	 * 분류정보 저장
	 * @param articleId 기술문서 관리번호
	 * @param categoryId 주제어 관리번호
	 */
	public void tag(Integer articleId, Integer categoryId);

}
