package net.webapp2.article.dao.ibatis;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import net.webapp2.article.dao.ArticleDao;
import net.webapp2.article.domain.Article;
import net.webapp2.article.domain.Category;

import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;

public class ArticleDaoSupport extends SqlMapClientDaoSupport implements
		ArticleDao {

	private static final String CATEGORY_ID = "category_id";
	private static final String ARTICLE_ID = "article_id";

//	public Integer issue(TotalType type) {
//
//		Integer id = (Integer) getSqlMapClientTemplate().queryForObject(
//				"Article.issue", type);
//
//		logger.debug(type.getLabel() + " 관리번호: " + id + "발행");
//
//		return id;
//
//	}

	public void insert(Article article) {

		logger.debug("Article 게시: " + article.toString());

		getSqlMapClientTemplate().insert("Article.insert", article);
	}

//	public void updateTotal(TotalType type) {
//
//		logger.debug("관리번호 갱신");
//
//		getSqlMapClientTemplate().update("Article.updateTotal", type.toString());
//
//	}

	public Article getArticle(Integer id) {

		logger.debug("관리번호: " + id + " 기술 문서 요청");

		return (Article) getSqlMapClientTemplate().queryForObject(
				"Article.get", id);
	}

//	public void save(Article article) {
//
//		if (article.getId() == null)
//			throw new IllegalArgumentException("수정대상 객체에 기술문서 관리번호가 없습니다.");
//
//		getSqlMapClientTemplate().update("Article.update", article);
//
//		// 분류(tag) 처리
//		if (article.getTagList() != null) {
//
//			Integer id = article.getId();
//
//			for (Category category : article.getTagList()) {
//				Map<String, Object> params = new HashMap<String, Object>();
//				params.put(ARTICLE_ID, id);
//				params.put(TotalType.category.toString(), category);
//
//				getSqlMapClientTemplate().insert("Article.tag", params);
//			}
//		}
//	}

	public void insert(Category category) {

		logger.debug("Category 등록: " + category.toString());

		getSqlMapClientTemplate().insert("Article.insertCategory", category);

	}

	public Category getCategory(Integer id) {
		logger.debug("관리번호: " + id + " 주제어 요청");

		return (Category) getSqlMapClientTemplate().queryForObject(
				"Article.getCategory", id);
	}

	public void save(Category category) {

		if (category.getId() == null)
			throw new IllegalArgumentException("수정대상 객체에 기술문서 관리번호가 없습니다.");

		getSqlMapClientTemplate().update("Article.updateCategory", category);
	}

	public List<Article> queryForArticleList() {
		// TODO Auto-generated method stub
		return null;
	}

	public void save(Article article) {
		// TODO Auto-generated method stub

	}

	public void tag(Integer articleId, Integer categoryId) {
		Map<String, Object> params = new HashMap<String, Object>();
		params.put(ARTICLE_ID, articleId);
		params.put(CATEGORY_ID, categoryId);

		getSqlMapClientTemplate().insert("Article.tag", params);
	}

	//
	// /**
	// * 특정 기술문서의 카테고리 부여 사항을 모두 지우고 새로 갱신한다.
	// *
	// * @param id
	// * 기술문서 관리번호
	// * @param tagList
	// * 새로운 카테고리 부여 목록
	// * @return 변경된 데이터베이스 레코드 개수
	// */
	// private int updateTagList(Integer id, List<String> tagList) {
	// int rows = 0;
	//
	// rows += resetTagList(id);
	// insertTagList(id, tagList);
	//
	// return rows += tagList.size();
	// }
	//
	// private void insertTagList(Integer id, List<String> tagList) {
	// Map<String, Object> paramMap = new HashMap<String, Object>();
	// paramMap.put("id", id);
	//
	// for (String category : tagList) {
	// System.out.println(id + " 문서에 " + category.toString() + " 카테고리 설정");
	// paramMap.put("category", category);
	// getSqlMapClientTemplate().insert("Article.insertTag", paramMap);
	// paramMap.remove("category");
	// }
	// }
	//
	// /**
	// * 특정 기술문서의 카테고리 부여 사항을 모두 지움
	// *
	// * @param id
	// * 기술문서 관리번호
	// * @return 변경된 데이터베이스 레코드 개수
	// */
	// private int resetTagList(Integer id) {
	// return getSqlMapClientTemplate().update("Article.resetTagList", id);
	// }
	//
	// public int delete(Integer id) {
	// int row = getSqlMapClientTemplate().delete("Article.delete", id);
	// System.out.println(row);
	// getSqlMapClientTemplate().update("Article.deleteOk", row);
	// return row;
	// }

	// public Integer count() {
	//
	// return (Integer) getSqlMapClientTemplate().queryForObject(
	// "Article.count", null);
	//
	// }
	//
	// @SuppressWarnings("unchecked")
	// public Map<String, Integer> countAsItIs() {
	// return (Map<String, Integer>) getSqlMapClientTemplate().queryForObject(
	// "Article.countAsItIs", null);
	// }
	//
	// public void resetStat(Integer issueCount, Integer delCount) {
	//
	// System.out.println("Article 통계치 데이터베이스 보정을 수행합니다.");
	//
	// getSqlMapClientTemplate().update("Article.resetIssueCount", issueCount);
	// getSqlMapClientTemplate().update("Article.resetDelCount", delCount);
	//
	// System.out.println("Article 통계치 데이터베이스 보정을 성공적으로 수행했습니다.");
	//
	// }
	//
	// @SuppressWarnings("unchecked")
	// public List<Article> allArticleList() {
	//
	// return getSqlMapClientTemplate().queryForList("Article.allArticleList",
	// null);
	//
	// }

}
