package net.webapp2.article.service;

import java.util.List;

import net.webapp2.article.domain.Article;
import net.webapp2.article.domain.Category;


public interface ArticleBoard {

	/**
	 * 기술문서를 게시판에 게시하고, 성공적으로 게시한 경우 해당 객체를 반환
	 *
	 * @param entry 추가할 기술문서
	 */
	public void post(Article entry);

	public Category add(Category category);

	/**
	 * 관리번호를 이용하여 게시판에 특정 기술문서를 올림
	 *
	 * @param articleId
	 *            기술문서 관리번호
	 * @return 기술문서 객체
	 */
	public Article get(Integer articleId);
//
//	/**
//	 * 기술문서 갱신 내용을 게시판에 반영. 별도의 지정이 없으면 최종 갱신 일시는 현재 시각이 반영됨.
//	 *
//	 * @param article
//	 *            갱신된 상태의 기술문서
//	 */
//	public void update(Article article);
//
//	/**
//	 * 관리번호를 이용하여 게시판에 특정 기술문서를 삭제
//	 *
//	 * @param articleId
//	 *            기술문서 관리번호
//	 * @return 1-삭제 성공, 0-실패
//	 */
//	public Integer remove(Integer articleId);
//
//	/**
//	 * 게시된 기술문서 개수 반환
//	 *
//	 * @return 게시된 기술문서 개수
//	 */
//	public Integer count();
//
//	/**
//	 * 통계 자료가 실제 데이터를 반영하는지 여부를 확인하고,
//	 * 불일치가 발생하면 통계 자료를 실제 데이터에 따라 수정한다.
//	 *
//	 * @return 건전한 경우 true, 건전성 확보가 요구되는 경우 false
//	 */
//	public boolean healthCheck();
//
//	/**
//	 * 게시된 모든 기술문서 반환
//	 * @return 모든 기술문서
//	 */
	public List<Article> list();

}
