package net.webapp2.article.domain;

import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

public class ArticleTest {

	@Test
	public void 주제어부여(){

		Article article = new Article();
		Category spring = new Category("Spring");
		article.tag(spring);

		List<Category> categoryList = new ArrayList<Category>();
		categoryList.add(spring);

		AssertJUnit.assertEquals(categoryList, article.getTagList());
		AssertJUnit.assertTrue(article.isTagged(spring));

	}

	/**
	 * 디폴트 생성자로 Article 객체를 생성하고
	 * 주요 속성 설정하기
	 * @throws MalformedURLException
	 * @throws URISyntaxException
	 * @throws MalformedURLException
	 */
	@Test
	public void 디폴트생성자와_setters확인() throws MalformedURLException{

		String title = "A Brief Introduction to IoC";
		String link = "http://today.java.net/lpt/a/73";
		String description = "IoC에 대한 간략한 소개글입니다.";
		Date date = new Date();
		List<Category> categoryList = new ArrayList<Category>();
		Category spring = new Category("Spring");
		categoryList.add(spring);

		Article entry = new Article();
		entry.setTitle(title);
		entry.setLink(link);
		entry.setDescription(description);
		entry.setPostedTime(date);
		entry.setTagList(categoryList);
		entry.setLanguage(Language.en);

		AssertJUnit.assertEquals(title, entry.getTitle());
		AssertJUnit.assertEquals(link, entry.getLink());
		AssertJUnit.assertEquals(description, entry.getDescription());
		AssertJUnit.assertEquals(date, entry.getPostedTime());
		AssertJUnit.assertEquals(categoryList, entry.getTagList());
		AssertJUnit.assertEquals(Language.en, entry.getLanguage());

	}

}
