package net.webapp2.article.service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import net.webapp2.article.domain.Article;
import net.webapp2.article.domain.Category;
import net.webapp2.article.domain.Language;
import net.webapp2.util.date.DateUtils;
import net.webapp2.util.test.AssertUtils;
import net.webapp2.util.test.TestBase;

import org.testng.annotations.Test;

/**
 * @author younghoe
 *
 */
public class ArticleBoardTest extends TestBase {

	/**
	 * 아티클 정보 등록 입력 항목: 제목, URL, 설명, 날짜 선택 항목: 카테고리, 언어
	 */
	@Test
	public void 기술문서게시_및_조회() {

		Article entry = 기술문서입력();
		ArticleBoard articleBoard = (ArticleBoard) getBean("articleBoard");
		articleBoard.post(entry);

		Article article = articleBoard.get(entry.getId());

		AssertUtils.equals(entry.getId(), article.getId());
		AssertUtils.equals(entry.getTitle(), article.getTitle());
		AssertUtils.equals(entry.getLink(), article.getLink());
		AssertUtils.equals(entry.getDescription(), article.getDescription());
		AssertUtils.equals(entry.getPostedTime(), article.getPostedTime());
		AssertUtils.equals(entry.getTagList(), article.getTagList());
		AssertUtils.equals(entry.getLanguage(), article.getLanguage());
	}

	private Article 기술문서입력() {

		String title = "A Brief Introduction to IoC";
		String link = "http://today.java.net/lpt/a/73";
		String description = "IoC에 대한 간략한 소개글입니다.";
		Date date = DateUtils.getDate(2006, 4, 5);
		List<Category> categoryList = new ArrayList<Category>();

		categoryList.add(new Category("Spring"));
		categoryList.add(new Category("iBatis"));
		categoryList.add(new Category("Webapp2"));

		Article entry = new Article();
		entry.setTitle(title);
		entry.setLink(link);
		entry.setDescription(description);
		entry.setPostedTime(date);
		entry.setTagList(categoryList);
		entry.setLanguage(Language.kr);

		return entry;
	}

	// public void 주제어등록(){
	// Category category = new Category("Spring");
	// category.setId(1);
	//
	// ArticleBoard articleBoard = (ArticleBoard) getBean("articleBoard");
	// Category result = articleBoard.add(category);
	//
	// AssertUtils.equals(category, result);
	//
	// }

	// @Test(dependsOnMethods = "post")
	// public void readAndUpdate() {
	//
	// ArticleBoard articleBoard = (ArticleBoard) getBean("articleBoard");
	// Article article = articleBoard.load(articleId);
	// String updatedDescription = "생각보다 더 좋네.";
	// Date lastmodified = article.getLastModified();
	//
	// AssertJUnit.assertNotSame(updatedDescription, article.getDescription());
	//
	// article.setDescription(updatedDescription);
	// articleBoard.update(article);
	//
	// Article updatedArticle = articleBoard.load(articleId);
	//
	// AssertJUnit.assertNotNull(updatedArticle);
	// AssertJUnit.assertEquals(updatedDescription, updatedArticle
	// .getDescription());
	// AssertJUnit.assertNotSame(lastmodified, updatedArticle
	// .getLastModified());
	//
	// }
	//
	// @Test(dependsOnMethods = "readAndUpdate")
	// public void remove() {
	// ArticleBoard articleBoard = (ArticleBoard) getBean("articleBoard");
	// Integer row = articleBoard.remove(articleId);
	// AssertJUnit.assertEquals(new Integer(1), row);
	// }
	//
	// @Test
	// public void verifyStat() {
	// ArticleBoard articleBoard = (ArticleBoard) getBean("articleBoard");
	// Integer total = articleBoard.count();
	// System.out.println("기술문서 총계: " + total);
	//
	// }
	//
	// /**
	// * article.dao.ArticleDaoTest를 먼저 수행하거나 DB에 직업 입력/삭제하고 나면 Fail 후 Success
	// 해야
	// * 정상 수행
	// */
	// @Test
	// public void healthCheck() {
	// ArticleBoard articleBoard = (ArticleBoard) getBean("articleBoard");
	// AssertJUnit.assertTrue(articleBoard.healthCheck());
	// }

	// ///////////////////////////////////////////////////////////////////
	// non-test method //
	// ///////////////////////////////////////////////////////////////////

}
