package net.webapp2.util.jdbc;

import javax.sql.DataSource;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.jdbc.core.JdbcTemplate;

/**
 * Parameter나 Result가 없는 간단한 SQL 문장 처리기
 * @author younghoe
 *
 */
public class SimpleSqlExecutor {

	private final Log logger = LogFactory.getLog(getClass());

	private JdbcTemplate jdbcTemplate;

	private DataSource dataSource;

	public void setDataSource(DataSource dataSource) {
		this.dataSource = dataSource;
	}

	/**
	 * 주어진 SQL 문을 수행
	 */
	public void execute(String statement) {
		// execute sql
		jdbcTemplate = new JdbcTemplate(dataSource);

		logger.info("다음의 SQL 문을 수행합니다:");
		logger.info(statement);

		jdbcTemplate.execute(statement);
	}
}
