package net.webapp2.temp;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Date;
import java.util.Map;

import javax.sql.DataSource;

import net.webapp2.util.jdbc.SimpleSqlExecutor;
import net.webapp2.util.test.PropertyDefinitionNotFoundException;
import net.webapp2.util.test.TestBase;

import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;
import org.testng.annotations.Configuration;
import org.testng.annotations.Test;

import com.ibatis.sqlmap.client.SqlMapClient;

public class HsqlDateTypeTest extends TestBase {

	@Test
	public void test() {

		Date utilDate = new Date();
		java.sql.Date sqlDate = new java.sql.Date(utilDate.getTime());

		System.out.println(utilDate.toString());
		System.out.println(sqlDate.toString());


		TestDateDao dao = new TestDateDao();
		Map<String, Date> dates = dao.insertAndGetDates(utilDate);

		Date dateInDate = dates.get("date1");
		Date dateInTIMESTAMP = dates.get("date2");
		Date dateInDATETIME = dates.get("date3");
		Date dateInTIMESTAMP0 = dates.get("date4");

		isTrue(sqlDate.getTime() > dateInDate.getTime());
		equals(sqlDate, dateInTIMESTAMP);
		equals(sqlDate, dateInDATETIME);
		equals(sqlDate, dateInTIMESTAMP0);

		isTrue(utilDate.getTime() > dateInDate.getTime());
		equals(utilDate.getTime(), dateInTIMESTAMP.getTime());
		equals(utilDate.getTime(), dateInDATETIME.getTime());
		equals(utilDate.getTime(), dateInTIMESTAMP0.getTime());

	}

	// ///////////////////////////////////////////////////////////////////
	// non-test method //
	// ///////////////////////////////////////////////////////////////////

	public HsqlDateTypeTest() throws FileNotFoundException, IOException,
			PropertyDefinitionNotFoundException {
		super();
		// TODO Auto-generated constructor stub
	}

	@Configuration(beforeTestMethod = true)
	public void setUp() {

		SimpleSqlExecutor executor = new SimpleSqlExecutor();
		DataSource dataSource = (DataSource) getBean("dataSource");
		executor.setDataSource(dataSource);

		String statement = "DROP TABLE Test IF EXISTS";
		executor.execute(statement);

		statement = "CREATE TABLE Test(" + "date1 DATE," + "date2 TIMESTAMP,"
				+ "date3 DATETIME," + "date4 TIMESTAMP(0)" + ")";
		executor.execute(statement);

	}

	class TestDateDao extends SqlMapClientDaoSupport {

		Map<String, Date> insertAndGetDates(Date date) {
			setSqlMapClient((SqlMapClient) getBean("sqlMapClient"));
			getSqlMapClientTemplate().insert("JustForTest.insertDates", date);
			return (Map<String, Date>) getSqlMapClientTemplate().queryForObject(
					"JustForTest.getDates", null);
		}

	}

}
