package net.webapp2.util.date;

import java.text.SimpleDateFormat;
import java.util.Date;

import net.webapp2.util.test.TestBase;

import org.testng.AssertJUnit;
import org.testng.annotations.ExpectedExceptions;
import org.testng.annotations.Test;

public class DateUtilsTest extends TestBase{

	@Test(groups="function")
	public void 년일월입력으로_Date_객체얻기(){

		Date date = DateUtils.getDate(2006, 4, 5);
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");

		equals("2006-04-05", dateFormat.format(date));

	}

	@Test(groups="exception")
	@ExpectedExceptions(IllegalArgumentException.class)
	public void 연으로_1년_이전_입력(){

		Date date = DateUtils.getDate(-1, 4, 5);
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");

		// 1 입력시 0001, 0 입력시 0001, -1 입력시 0002
		AssertJUnit.assertEquals("0002-04-05", dateFormat.format(date));
	}

	@Test(groups="exception")
	@ExpectedExceptions(IllegalArgumentException.class)
	public void 월로_0이하_입력시(){

		Date date = DateUtils.getDate(2006, 0, 5);
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");

		// 0 입력시 이전해 12, -1 입력시 이전해 11
		AssertJUnit.assertEquals("2005-12-05", dateFormat.format(date));
	}

	@Test(groups="exception")
	@ExpectedExceptions(IllegalArgumentException.class)
	public void 월로_13이상_입력시(){

		Date date = DateUtils.getDate(2006, 13, 5);
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");

		// 13 입력시 다음해 1
		AssertJUnit.assertEquals("2007-01-05", dateFormat.format(date));
	}

	@Test(groups="exception")
	@ExpectedExceptions(IllegalArgumentException.class)
	public void 일로_0이하_입력시(){

		Date date = DateUtils.getDate(2006, 3, 0);
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");

		// 0 입력시 이전달 말일
		AssertJUnit.assertEquals("2006-02-28", dateFormat.format(date));
	}

	@Test(groups="exception")
	@ExpectedExceptions(IllegalArgumentException.class)
	public void 일로_32이상_입력시(){

		Date date = DateUtils.getDate(2006, 4, 32);
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");

		// 13 입력시 다음해 1
		AssertJUnit.assertEquals("2006-05-02", dateFormat.format(date));
	}

}
