package net.webapp2.util.jdbc;

import javax.sql.DataSource;

import net.webapp2.util.test.TestBase;

import org.springframework.jdbc.UncategorizedSQLException;
import org.testng.annotations.Configuration;
import org.testng.annotations.ExpectedExceptions;
import org.testng.annotations.Test;

public class SimpleSqlExecutorTest extends TestBase {

	@Test(groups = "function")
	public void SQL수행_테이블생성() {

		SimpleSqlExecutor executor = new SimpleSqlExecutor();
		DataSource dataSource = (DataSource) getBean("dataSource");
		executor.setDataSource(dataSource);

		String createStatement = "CREATE TABLE Test("
				+ " id VARCHAR(10), district VARCHAR(10))";
		executor.execute(createStatement);

	}

	@Test(groups = "exception")
	@ExpectedExceptions(UncategorizedSQLException.class)
	public void SQL수행_테이블_중복_생성() {

		SimpleSqlExecutor executor = new SimpleSqlExecutor();
		DataSource dataSource = (DataSource) getBean("dataSource");
		executor.setDataSource(dataSource);

		String createTableStatement = "CREATE TABLE Test("
				+ " id VARCHAR, district VARCHAR)";
		executor.execute(createTableStatement);
		executor.execute(createTableStatement);

	}

	@Test(groups = "exception")
	@ExpectedExceptions(UncategorizedSQLException.class)
	public void 잘못된_SQL수행() {

		SimpleSqlExecutor executor = new SimpleSqlExecutor();
		DataSource dataSource = (DataSource) getBean("dataSource");
		executor.setDataSource(dataSource);

		String createTableStatement = "CREAT SABLE Test("
				+ " id VARCHAR, district VARCHAR)";
		executor.execute(createTableStatement);

	}

	// ///////////////////////////////////////////////////////////////////
	// non-test method //
	// ///////////////////////////////////////////////////////////////////

	@SuppressWarnings("unused")
	@Configuration(beforeTestMethod = true, afterTestMethod = true, groups = "always")
	private void 테스트_테이블_제거() {

		SimpleSqlExecutor executor = new SimpleSqlExecutor();
		DataSource dataSource = (DataSource) getBean("dataSource");
		executor.setDataSource(dataSource);

		String statement = "DROP TABLE Test IF EXISTS";
		executor.execute(statement);

	}
}
