package net.webapp2.util.test;

import java.io.FileNotFoundException;
import java.io.IOException;

import net.webapp2.util.jdbc.SimpleSqlExecutor;

import org.springframework.beans.factory.BeanDefinitionStoreException;
import org.testng.AssertJUnit;
import org.testng.annotations.ExpectedExceptions;
import org.testng.annotations.Parameters;
import org.testng.annotations.Test;

public class TestBaseTest {


	final String APPLICATION_CONTEXT_FILE_PATH_PROPERTY = "application.conext.file.path";


	@Test(groups="exception")
	@Parameters("CONTEXT_PROPERTIES 파일을 잘못 지정")
	@ExpectedExceptions(FileNotFoundException.class)
	public void CONTEXT_PROPERTIES_파일이_없는_경우(String fileName)
			throws FileNotFoundException, IOException,
			PropertyDefinitionNotFoundException {

		SpringBasedTester_객체_생성_및_setUp(fileName);

	}

	@Test(groups="exception")
	@Parameters("DAO_CONTEXT_FILE_PATH 항목이 없는 파일")
	@ExpectedExceptions(PropertyDefinitionNotFoundException.class)
	public void DAO_CONTEXT_FILE_PATH_항목이_없는_경우(String fileName)
			throws FileNotFoundException, IOException,
			PropertyDefinitionNotFoundException {

		SpringBasedTester_객체_생성_및_setUp(fileName);

	}

	@Test(groups="exception")
	@Parameters("DAO_CONTEXT_FILE_PATH 값이 설정 안된 파일")
	@ExpectedExceptions(PropertyDefinitionNotFoundException.class)
	public void DAO_CONTEXT_FILE_PATH_값이_빈_경우(String fileName)
			throws FileNotFoundException, IOException,
			PropertyDefinitionNotFoundException {

		SpringBasedTester_객체_생성_및_setUp(fileName);

	}

	@Test(groups="exception")
	@Parameters("DAO_CONTEXT_FILE_PATH 값을 잘못 지정한 파일")
	@ExpectedExceptions( { FileNotFoundException.class,
			BeanDefinitionStoreException.class })
	public void DAO_CONTEXT_FILE_PATH_로_설정된_파일이_없는_경우(String fileName)
			throws FileNotFoundException, IOException,
			PropertyDefinitionNotFoundException {

		SpringBasedTester_객체_생성_및_setUp(fileName);

	}


	@Test(groups="exception")
	@Parameters("APPLICATION_CONTEXT_FILE_PATH 항목이 없는 파일")
	@ExpectedExceptions(PropertyDefinitionNotFoundException.class)
	public void APPLICATION_CONTEXT_FILE_PATH_항목이_없는_경우(String fileName)
			throws FileNotFoundException, IOException,
			PropertyDefinitionNotFoundException {

		SpringBasedTester_객체_생성_및_setUp(fileName);

	}

	@Test(groups="exception")
	@Parameters("APPLICATION_CONTEXT_FILE_PATH 값이 설정 안된 파일")
	@ExpectedExceptions(PropertyDefinitionNotFoundException.class)
	public void APPLICATION_CONTEXT_FILE_PATH_값이_빈_경우(String fileName)
			throws FileNotFoundException, IOException,
			PropertyDefinitionNotFoundException {

		SpringBasedTester_객체_생성_및_setUp(fileName);

	}

	@Test(groups="exception")
	@Parameters("APPLICATION_CONTEXT_FILE_PATH 값을 잘못 지정한 파일")
	@ExpectedExceptions( {BeanDefinitionStoreException.class })
	public void APPLICATION_CONTEXT_FILE_PATH_로_설정된_파일이_없는_경우(String fileName)
			throws FileNotFoundException, IOException,
			PropertyDefinitionNotFoundException {

		SpringBasedTester_객체_생성_및_setUp(fileName);

	}

	@Test(groups="exception")
	@Parameters("잘못된 형식의 DAO_CONTEXT_FILE")
	@ExpectedExceptions(BeanDefinitionStoreException.class)
	public void 잘못된_형식의_DAO_CONTEXT_FILE(String fileName) throws FileNotFoundException, IOException, PropertyDefinitionNotFoundException{

		SpringBasedTester_객체_생성_및_setUp(fileName);

	}

	@Test(groups="exception")
	@Parameters("잘못된 형식의 APPLICATION_CONTEXT_FILE")
	@ExpectedExceptions(BeanDefinitionStoreException.class)
	public void 잘못된_형식의_APPLICATION_CONTEXT_FILE(String fileName) throws FileNotFoundException, IOException, PropertyDefinitionNotFoundException{

		SpringBasedTester_객체_생성_및_setUp(fileName);

	}

	@Test(groups="function")
	public void 테스트클래스에서_FACTORY_객체얻기() throws FileNotFoundException, IOException, PropertyDefinitionNotFoundException{

		TestBase testClass = new Temp();

		AssertJUnit.assertNotNull(testClass.getBeanFactory());

	}

	@Test(groups="function")
	public void assertion_메소드_확인(){

		Temp test = new Temp();
		test.equals("hi", "hi");
		test.isFalse(false);
		test.isTrue(true);
		test.isNull(null);
		test.same("hi", "hi");
		test.notNull("hi");
		test.notSame("hi", "hello");

	}

	@Test(groups="function")
	public void SimpleSqlExecutor_획득(){

		TestBase test = new Temp();
		SimpleSqlExecutor executor = test.getSqlExecutor();
		test.notNull(executor);

	}

	// ///////////////////////////////////////////////////////////////////
	// non-test method //
	// ///////////////////////////////////////////////////////////////////

	private class Temp extends TestBase {

		public Temp(String fileName) throws FileNotFoundException, IOException, PropertyDefinitionNotFoundException {
			super(fileName);
		}

		public Temp(){super();}

	}

	private void SpringBasedTester_객체_생성_및_setUp(String fileName)
			throws FileNotFoundException, IOException,
			PropertyDefinitionNotFoundException {

		@SuppressWarnings("unused") TestBase testClass = new Temp(fileName);

	}

}