package net.webapp2.userinfo.dao;

import java.util.List;

import net.webapp2.userinfo.domain.UserInfo;

public interface UserInfoDao {

	/**
	 * 데이터베이스에 새로운 UserInfo 객체를 저장
	 * @param userinfo
	 */
	public void insert(UserInfo userinfo);

	/**
	 * 데이터베이스에 수정된 UserInfo 객체를 저장
	 * @param userinfo
	 * @return
	 */
	public int 	save(UserInfo userinfo);

	/**
	 * 테이터베이스에서 특정 UserInfo 레코드를 삭제
	 * @param id
	 * @return
	 */
	public int	delete(int id);


	/**
	 * 전체 사용자의 목록을 가져온다.
	 * @return List<UserInfo>
	 */
	public List<UserInfo> list();

	/**
	 * 주어진 속성 값으로 주어진 키워드를 갖는 UserInfo 객체 반환
	 * @param property
	 * @param keyword
	 * @return
	 */
	public UserInfo queryForUserInfo(String property, Object keyword);

}
