package net.webapp2.userinfo.service;

import net.webapp2.userinfo.domain.UserInfo;

/**
 * @author younghoe
 *
 */
public interface UserInfoService {

	/**
	 * 회원 가입 혹은 사용자 등록. 등록 과정에서 id와 createdDate가 부여됨.
	 * @param userinfo id와 createdDate 속성은 무시된다.
	 */
	public void sign(UserInfo userinfo);

	/**
	 * @param userinfo
	 * @return update된 레코드의 수
	 */
	public int	save(UserInfo userinfo);

	/**
	 * 관리번호(id)를 이용하여 UserInfo 객체 획득
	 * @param id
	 * @return userinfo객체
	 */
	public UserInfo get(Integer id);

	/**
	 * @param id
	 * @return delete된 레코드의 수
	 */
	public int	delete(int id);

	/**
	 * 주어진 이메일을 갖는 사용자 정보 검색
	 * @param email
	 * @return 대응되는 사용자 정보가 없는 경우 null
	 */
	public UserInfo findByEmail(String email);
}
