package net.webapp2.userinfo.service.support;

//import net.webapp2.common.managedobject.dao.ibatis.ManagedObjectDaoImpl;
import java.util.Date;

import net.webapp2.common.managedobject.dao.ManagedObjectDao;
import net.webapp2.userinfo.dao.UserInfoDao;
import net.webapp2.userinfo.domain.UserInfo;
import net.webapp2.userinfo.service.UserInfoService;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class UserInfoServiceSupport implements UserInfoService{

	private UserInfoDao userinfoDao;
	private ManagedObjectDao userinfoMod;

	private Log logger = LogFactory.getLog(getClass());

	public void setUserinfoDao(UserInfoDao userinfoDao) {
		this.userinfoDao = userinfoDao;
	}

	public void sign(UserInfo userinfo) {

		logger.debug("sign request!");

		int id = userinfoMod.issue();
		logger.debug("new issue number for userinfo: " + id);

		userinfo.setId(id); // assign the issue number for userinfo id
		userinfo.setCreatedDate(new Date()); // timestamp

		userinfoDao.insert(userinfo);

		userinfoMod.updateFor(ManagedObjectDao.INSERT);
		logger.debug("update managed object recored for userinfo insert");

	}

	public int save(UserInfo userinfo) {
		return userinfoDao.save(userinfo);
	}

	public UserInfo get(Integer id) {
		return userinfoDao.queryForUserInfo("id", id);
	}

	public <List>UserInfo list() {
		return (UserInfo) userinfoDao.list();
	}

	public int delete(int id) {
		int rows = userinfoDao.delete(id);
		if(rows>0) {
//			managedObject.updateFor(-1, "userinfo");
//			userinfoDao.updateDel("userinfo");
		}
		return rows;
	}

	public void setUserinfoMod(ManagedObjectDao userinfoMod) {
		this.userinfoMod = userinfoMod;
	}

	public UserInfo findByEmail(String email) {

		if(email != null){
			return userinfoDao.queryForUserInfo("email", email);
		}else{
			return null;
		}

	}

}
