package net.webapp2.userinfo.dao.ibatis;

import java.util.Date;

import javax.sql.DataSource;

import net.webapp2.userinfo.dao.UserInfoDao;
import net.webapp2.userinfo.domain.District;
import net.webapp2.userinfo.domain.UserInfo;
import net.webapp2.util.jdbc.SimpleSqlExecutor;
import net.webapp2.util.test.AssertUtils;
import net.webapp2.util.test.TestBase;

import org.testng.annotations.Configuration;
import org.testng.annotations.Test;

public class UserInfoDaoSupportTest extends TestBase{

	private UserInfoDao userinfoDao;

	@Test
	public void insert_and_get(){

		// 서비스 구현시 주의사항
		// 1. ID는 ManagedObjectDao를 통해 얻음
		// 2. 가입일시는 서비스 책임 -> 날짜 객체 생성
		UserInfo userinfo = userinfo입력얻기();

		userinfoDao.insert(userinfo);

		UserInfo savedUserinfo = userinfoDao.queryForUserInfo("id", 1);
		AssertUtils.equals(userinfo, savedUserinfo);

		AssertUtils.equals(userinfo.getId(), savedUserinfo.getId());
		AssertUtils.equals(userinfo.getAlias(), savedUserinfo.getAlias());
		AssertUtils.equals(userinfo.getBlog(), savedUserinfo.getBlog());
		AssertUtils.equals(userinfo.getDomicile(), savedUserinfo.getDomicile());
		AssertUtils.equals(userinfo.getCreatedDate(), savedUserinfo.getCreatedDate());
		AssertUtils.equals(userinfo.getName(), savedUserinfo.getName());
		AssertUtils.equals(userinfo.getEmail(), savedUserinfo.getEmail());
		AssertUtils.equals(userinfo.getPassword(), savedUserinfo.getPassword());

	}



	@Test
	public void queryForUserInfo_emil로(){

		String email1 = "test@webapp2.net";
		UserInfo signed = userinfo입력얻기();
		signed.setEmail(email1);
		userinfoDao.insert(signed);

		UserInfo userinfo1 = userinfoDao.queryForUserInfo("email", email1);
		AssertUtils.equals(signed, userinfo1);
		AssertUtils.equals(signed.getEmail(), userinfo1.getEmail());

		String email2 = "diff@webapp2.net";
		UserInfo userinfo2 = userinfoDao.queryForUserInfo("email", email2);
		AssertUtils.isNull(userinfo2);

	}


//	@Test
//	public int save() {
//
//		UserInfoDao userinfoDao = (UserInfoDao) getBean("userinfoDao");
//
//		AssertUtils.notNull(userinfoDao);
//
//		UserInfo userinfo = new UserInfo();
//		userinfo.setId(1);
//		userinfo.setAlias("조기출근");
//		userinfo.setBlog("http://blog.naver.com/evilimp");
//		userinfo.setDomicile(District.abroad);
//		userinfo.setName("최한수");
//		userinfo.setEmail("evilimp@naver.com");
//		userinfo.setPassword("1111");
//
//		return userinfoDao.save(userinfo);
//	}

//	@Test
//	public int delete() {
//
//		UserInfoDao userinfoDao = (UserInfoDao) getBean("userinfoDao");
//
//		AssertUtils.notNull(userinfoDao);
//
//		return userinfoDao.delete(4);
//	}



//	@Test
//	public <List>UserInfo list() {
//
//		UserInfoDao userinfoDao = (UserInfoDao) getBean("userinfoDao");
//
//		AssertUtils.notNull(userinfoDao);
//
//		return  (UserInfo) userinfoDao.list();
//	}


	/////////////////////////////////////////////////////////////////////
	// non-test method 												   //
	/////////////////////////////////////////////////////////////////////


	@SuppressWarnings("unused")
	@Configuration(beforeTestMethod=true)
	private void 데이터베이스_초기화_및_DAO_준비() {

		SimpleSqlExecutor executor = new SimpleSqlExecutor();
		DataSource dataSource = (DataSource) getBean("dataSource");
		executor.setDataSource(dataSource);

		String statement = "DROP TABLE UserInfo IF EXISTS";
		executor.execute(statement);

		statement = "CREATE TABLE UserInfo(" +
						"id INTEGER PRIMARY KEY," +
						"alias VARCHAR(25)," +
						"blog VARCHAR(255)," +
						"password VARCHAR(100) NOT NULL," +
						"createdDate DATETIME NOT NULL," +
						"email VARCHAR(255) NOT NULL," +
						"name VARCHAR(25) NOT NULL," +
						"domicile VARCHAR(10) NOT NULL" +
						");";
		executor.execute(statement);

	}

	@Configuration(beforeTestClass=true)
	public void userinfoDao_초기화(){
		userinfoDao = (UserInfoDao) getBean("userinfoDao");
	}

	/**
	 * @return
	 */
	private UserInfo userinfo입력얻기() {
		UserInfo userinfo = new UserInfo();
		userinfo.setId(1);
		userinfo.setAlias("칼퇴근");
		userinfo.setBlog("http://younghoe.info");
		userinfo.setDomicile(District.seoul);
		userinfo.setCreatedDate(new Date());
		userinfo.setName("안영회");
		userinfo.setEmail("test@test.com");
		userinfo.setPassword("huvahuva__12345");
		return userinfo;
	}

}
