package net.webapp2.userinfo.service.support;

import java.util.Date;

import javax.sql.DataSource;

import net.webapp2.userinfo.domain.District;
import net.webapp2.userinfo.domain.UserInfo;
import net.webapp2.userinfo.service.UserInfoService;
import net.webapp2.util.jdbc.SimpleSqlExecutor;
import net.webapp2.util.test.AssertUtils;
import net.webapp2.util.test.TestBase;

import org.testng.annotations.Configuration;
import org.testng.annotations.Test;

public class UserInfoServiceSupportTest extends TestBase {

	private UserInfoService userinfoService;

	@Test
	public void 이메일중복체크(){

		// 사용자 입력 - no id/createdDate
		UserInfo userinfo = 사용자화면입력획득();
		String email = "younghoe@webapp2.net";
		userinfo.setEmail(email);
		userinfo.setId(1);
		userinfo.setCreatedDate(new Date());
		userinfoService.sign(userinfo);

		UserInfo signed = userinfoService.findByEmail(email);
		AssertUtils.equals(userinfo, signed);
		AssertUtils.equals(userinfo.getEmail(), signed.getEmail());

		UserInfo none = userinfoService.findByEmail("none@webapp2.net");
		AssertUtils.isNull(none);

	}

	@Test
	public void 회원가입_및_조회() {

		// 사용자 입력 - no id/createdDate
		UserInfo userinfo = 사용자화면입력획득();

		AssertUtils.isNull(userinfo.getId());
		AssertUtils.isNull(userinfo.getCreatedDate());

		userinfoService.sign(userinfo);

		AssertUtils.notNull(userinfo.getId());
		AssertUtils.notNull(userinfo.getCreatedDate());

		UserInfo signed = userinfoService.get(userinfo.getId());
		AssertUtils.equals(userinfo.getAlias(), signed.getAlias());
		AssertUtils.equals(userinfo.getBlog(), signed.getBlog());
		AssertUtils.equals(userinfo.getDomicile(), signed.getDomicile());
		AssertUtils.equals(userinfo.getName(), signed.getName());
		AssertUtils.equals(userinfo.getEmail(), signed.getEmail());
		AssertUtils.equals(userinfo.getPassword(), signed.getPassword());
		AssertUtils.equals(userinfo.getId(), signed.getId());
		AssertUtils.equals(userinfo.getCreatedDate(), signed.getCreatedDate());

	}

	/**
	 * @return
	 */
	private UserInfo 사용자화면입력획득() {
		UserInfo userinfo = new UserInfo();
		userinfo.setAlias("칼퇴근");
		userinfo.setBlog("http://younghoe.info");
		userinfo.setDomicile(District.seoul);
		userinfo.setName("안영회");
		userinfo.setEmail("test@test.com");
		userinfo.setPassword("huvahuva");
		return userinfo;
	}

	// @Test
	// public void UserInfo수정() {
	//
	// UserInfoService userinfoService = (UserInfoService)
	// getBean("userinfoService");
	//
	// AssertUtils.notNull(userinfoService);
	//
	// UserInfo userinfo = new UserInfo();
	//
	// userinfo.setId(4);
	// userinfo.setAlias("조기출근");
	// userinfo.setBlog("http://blog.naver.com/evilimp");
	// userinfo.setDomicile(District.abroad);
	// userinfo.setName("최한수");
	// userinfo.setEmail("evilimp@naver.com");
	// userinfo.setPassword("1111");
	//
	// userinfoService.save(userinfo);
	// }

	// ///////////////////////////////////////////////////////////////////
	// non-test method //
	// ///////////////////////////////////////////////////////////////////

	@Configuration(beforeTestClass = true)
	public void 테스트대상준비() {
		userinfoService = (UserInfoService) getBean("userinfoService");
	}

	@SuppressWarnings("unused")
	@Configuration(beforeTestMethod = true)
	private void 데이터베이스_초기화_및_DAO_준비() {

		SimpleSqlExecutor executor = new SimpleSqlExecutor();
		DataSource dataSource = (DataSource) getBean("dataSource");
		executor.setDataSource(dataSource);

		String statement = "DROP TABLE UserInfo IF EXISTS";
		executor.execute(statement);

		statement = "CREATE TABLE UserInfo(" + "id INTEGER PRIMARY KEY,"
				+ "alias VARCHAR(25)," + "blog VARCHAR(255),"
				+ "password VARCHAR(100) NOT NULL,"
				+ "createdDate DATETIME NOT NULL,"
				+ "email VARCHAR(255) NOT NULL," + "name VARCHAR(25) NOT NULL,"
				+ "domicile VARCHAR(10) NOT NULL" + ");";
		executor.execute(statement);

		statement = "DROP TABLE ManagedObject" + " IF EXISTS";
		executor.execute(statement);

		statement = "CREATE TABLE ManagedObject("
				+ "type VARCHAR(10) PRIMARY KEY," + "issue INTEGER NOT NULL,"
				+ "del INTEGER NOT NULL);";
		executor.execute(statement);

		statement = "INSERT INTO ManagedObject VALUES('userinfo', 0, 0);";
		executor.execute(statement);

	}

}
