package net.webapp2.board.dao.ibatis;

import java.util.List;

import net.webapp2.board.dao.ArticleDao;
import net.webapp2.board.domain.Article;
import net.webapp2.board.domain.Writing;

import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;

public class ArticleDaoImpl extends SqlMapClientDaoSupport implements
		ArticleDao {

	@SuppressWarnings("unchecked")
	public List<Article> list() {
		return  getSqlMapClientTemplate().queryForList("Article.list", null);
	}

	@SuppressWarnings("unchecked")
	public List<Article> list(String keyword) {
		return  getSqlMapClientTemplate().queryForList("Article.listByKeyword", keyword);
	}

	public Writing view(int id) {
		return (Writing) getSqlMapClientTemplate().queryForObject("Article.view", id);
	}

	public void insert(Writing article) {
		getSqlMapClientTemplate().insert("Article.insert", article);
	}

	public int	update(Writing article) {
		return getSqlMapClientTemplate().update("Article.update", article);
	}

	public int	delete(int id) {
		return getSqlMapClientTemplate().delete("Article.delete", id);
	}
}
