package net.webapp2.board.web;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.webapp2.board.domain.Comment;
import net.webapp2.board.service.CommentService;
import net.webapp2.util.RequestUtil;
import net.webapp2.util.StringUtil;

import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.SimpleFormController;
import org.springframework.web.servlet.view.RedirectView;

public class CommentFormController extends SimpleFormController {

	private CommentService	commentService;

	protected Object formBackingObject(HttpServletRequest request) throws Exception {

		Comment comment = new Comment();
		int articleId = RequestUtil.getIntParam(request, "id", 1);
		comment.setArticleId(articleId);
		return comment;
	}

	@SuppressWarnings("unchecked")
	@Override
	protected Map referenceData(HttpServletRequest request) throws Exception {

		Map model = new HashMap();
		String submited = request.getParameter("submit");
		model.put("submit", submited);
		return model;
	}

	// submit이 일어 났을때 호출 되는 method
	protected ModelAndView onSubmit
	(HttpServletRequest request, HttpServletResponse response, Object command, BindException errors)
	throws Exception {

		ModelAndView successView = null;
		Comment comment = (Comment) command;
		String content = StringUtil.replaceAll(comment.getContents(), "\n", "<br/>");
		comment.setContents(content);
		commentService.insert(comment);
		successView = new ModelAndView(new RedirectView("comment.form"));
		successView.addObject("id", comment.getArticleId());
		successView.addObject("submit", "Y");
		return successView;

	}

	public void setCommentService(CommentService commentService) {
		this.commentService = commentService;
	}
}
