package net.webapp2.board.web;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.webapp2.board.domain.Article;
import net.webapp2.board.service.ArticleService;
import net.webapp2.util.RequestUtil;

import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractController;

public class ListController extends AbstractController {

	private ArticleService articleService;

	@Override
	protected ModelAndView handleRequestInternal(HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		String keyword;

		if(request.getParameter("keyword") == null) {
			keyword = "";
		} else {
			keyword = RequestUtil.getParam(request, "keyword");
		}

		List<Article> articleList = articleService.list(keyword);
//		List<Article> articleList = articleService.list();

		ModelAndView nextPage = new ModelAndView("list");
		nextPage.addObject("articleList", articleList);
		nextPage.addObject("keyword", keyword);
		return nextPage;

	}

	public void setArticleService(ArticleService articleService) {
		this.articleService = articleService;
	}

}
