package net.webapp2.userinfo.dao.ibatis;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import net.webapp2.userinfo.dao.UserInfoDao;
import net.webapp2.userinfo.domain.UserInfo;

import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;

public class UserInfoDaoSupport extends SqlMapClientDaoSupport implements
		UserInfoDao {

	public void insert(UserInfo userinfo) {

		logger.debug("insert: " + userinfo.toString());

		getSqlMapClientTemplate().insert("UserInfo.register", userinfo);

	}

	public UserInfo queryForUserInfo(String property, Object keyword) {

		logger.debug("query for userinfo of " + property + " is " + keyword);

		Map<String, Object> params = new HashMap<String, Object>();
		params.put("property", property);
		params.put("keyword", keyword);

		return (UserInfo) getSqlMapClientTemplate().queryForObject(
				"UserInfo.get", params);

	}

	public int save(UserInfo userinfo) {
		int rows = getSqlMapClientTemplate().update("UserInfo.save", userinfo);

		return rows;
	}

	public int delete(int id) {
		int rows = getSqlMapClientTemplate().delete("UserInfo.del", id);
		getSqlMapClientTemplate().update("UserInfo.updateDel", "userinfo");
		return rows;
	}

	@SuppressWarnings("unchecked")
	public List<UserInfo> list() {
		return getSqlMapClientTemplate().queryForList("UserInfo.list", null);
	}

}
