package net.webapp2.userinfo.web;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.webapp2.userinfo.domain.UserInfo;
import net.webapp2.userinfo.service.UserInfoService;

import org.springframework.validation.BindException;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.SimpleFormController;
import org.springframework.web.servlet.view.RedirectView;

public class SignController extends SimpleFormController {

	private UserInfoService userinfoService;

	// submit이 일어 났을때 호출 되는 method
	protected ModelAndView onSubmit
	(HttpServletRequest request, HttpServletResponse response, Object command, BindException errors)
	throws Exception {

		ModelAndView successView = null;
		UserInfo userInfo = (UserInfo) command;

		userinfoService.sign(userInfo);
		// application-context에 설정된 successview로 ModelAndView를 생성하고 model에 값을 설정한다.
		successView = new ModelAndView(new RedirectView(getSuccessView()));

		return successView;
	}

	/**
	 * @param userInfoService The userInfoService to set.
	 */
	public void setUserinfoService(UserInfoService userInfoService) {
		this.userinfoService = userInfoService;
	}

}
